import static java.lang.System.out;
import java.util.*;

public class GenAlternating {

    public static void main(String[] args) {
        if (args.length != 3)
            throw new RuntimeException("usage: GenAlternating segmentCount thickness1 thickness2");
        int count = Integer.parseInt(args[0]);
        int height1 = Integer.parseInt(args[1]);
        int height2 = Integer.parseInt(args[2]);
        int curLeft = 1;
        List<Integer> left = new ArrayList<>();
        List<Integer> right = new ArrayList<>();
        List<Integer> height = new ArrayList<>();
        for (int i = 0; i < count; i++) {
            left.add(curLeft);
            right.add(curLeft + 2);
            height.add(i % 2 == 0 ? height1 : height2);
            curLeft++;
            if (i % 3 == 2)
                curLeft += 2;
        }
        out.println(count + " " + Collections.max(right));
        for (int i = 0; i < count; i++)
            out.println(left.get(i) + " " + right.get(i) + " " + height.get(i));
    }
}
