import java.util.Random;

import static java.lang.System.out;

public class GenAntiRandom {

    public static void main(String[] args) {
        if (args.length != 1)
           throw new AssertionError("usage: count");
        int k = 7;
        int[] left = new int[]{1, 3, 8, 1, 1, 2, 1, 1};
        int[] right = new int[]{2, 9, 9, 2, 2, 6, 2, 4};
        int[] height = new int[]{1, 10, 1, 1, 5, 1, 4, 10};
        int n = Integer.parseInt(args[0]);
        out.println(n + " " + (k + 1));
        for (int i = 0; i < left.length; i++) {
            int l = left[i];
            int r = right[i];
            l = Math.max(l, 1);
            l = Math.min(l, k);
            r = Math.max(l, 1);
            r = Math.min(r, k);
            out.println(l + " " + r + " " + height[i]);
        }
        Random random = new Random(42);
        int maxX = 1000 * 1000;
        for (int i = left.length; i < n; i++) {
            int l = random.nextInt(maxX) - maxX / 2 + 1;
            int r = l + 1 + random.nextInt(maxX);
            l = Math.max(l, 1);
            l = Math.min(l, k);
            r = Math.max(l, 1);
            r = Math.min(r, k);
            out.println(l + " " + r + " " + 13);
        }
    }
}
