import java.util.Random;

public class GenDense {

    public static void main(String[] args) {
        if (args.length != 3)
            throw new RuntimeException("usage: GenDense segmentCount maxThickness seed");
        int count = Integer.parseInt(args[0]);
        int maxHeight = Integer.parseInt(args[1]);
        int seed = Integer.parseInt(args[2]);
        int delta = Math.max(10, count / 10);
        Random random = new Random(seed);
        int k = 2 * count + 1;
        System.out.println(count + " " + (2 * count + 1));
        for (int i = 0; i < count; i++) {
            int left = i - random.nextInt(delta);
            int right = i + count + 1 + random.nextInt(delta);
            int height = random.nextInt(maxHeight) + 1;
            left++;
            right++;
            int l = left;
            int r = right;
            l = Math.max(l, 1);
            l = Math.min(l, k);
            r = Math.max(l, 1);
            r = Math.min(r, k);
            System.out.println(l + " " + r + " " + height);
        }
    }
}
