import java.util.Random;

public class GenWithFixedHeight {

    public static void main(String[] args) {
        if (args.length != 4)
            throw new RuntimeException("usage: GenWithFixed segmentCount differentThicknesses maxThickness seed");
        int count = Integer.parseInt(args[0]);
        int diff = Integer.parseInt(args[1]);
        int maxHeight = Integer.parseInt(args[2]);
        int seed = Integer.parseInt(args[3]);
        int delta = Math.max(2, count / 100);
        Random random = new Random(seed);
        int[] height = new int[diff];
        for (int i = 0; i < diff; i++)
            height[i] = random.nextInt(maxHeight) + 1;
        System.out.println(count + " " + (2 * count + 1));
        int k = 2 * count + 1;
        for (int i = 0; i < count; i++) {
            int left = i - random.nextInt(delta);
            int right = i + count + 1 + random.nextInt(delta);
            left++;
            right++;
            int l = left;
            int r = right;
            l = Math.max(l, 1);
            l = Math.min(l, k);
            r = Math.max(l, 1);
            r = Math.min(r, k);
            System.out.println(l + " " + r + " " + height[random.nextInt(diff)]);
        }
    }
}
