import java.util.Random;

public class GenManyOpen {
    public static void main(String[] args) {
        if (args.length < 3) {
            System.err.println("Usage: GenManyOpen segmentsCount maxThickness seed");
            return;
        }
        int n = Integer.parseInt(args[0]);
        int maxThickness = Integer.parseInt(args[1]);
        Random random = new Random(Integer.parseInt(args[2]));
        System.out.println(n + " " + 3 * n);
        for (int i = 0; i < n / 2; i++)
            System.out.println(1 + " " + (n + n / 2 + i) + " " + (random.nextInt(maxThickness) + 1));
        for (int i = n / 2; i < n; i++)
            System.out.println((n + i - n / 2) + " " + 3 * n + " " + (random.nextInt(maxThickness) + 1));
    }
}
