import java.util.Random;

public class GenSeq {

    public static void main(String[] args) {
        if (args.length != 4)
            throw new RuntimeException("usage: GenSeq segmentCount segmentLen maxThickness seed");
        int count = Integer.parseInt(args[0]);
        int len = Integer.parseInt(args[1]);
        int maxHeight = Integer.parseInt(args[2]);
        int seed = Integer.parseInt(args[3]);
        Random random = new Random(seed);
        System.out.println(count + " " + (len * count));
        int k = len * count;
        for (int i = 0; i < count; i++) {
            int l = i * len + 1;
            int r = (i + 1) * len;
            l = Math.max(l, 1);
            l = Math.min(l, k);
            r = Math.max(l, 1);
            r = Math.min(r, k);
            System.out.println(l + " " + r + " " + (random.nextInt(maxHeight) + 1));
        }
    }
}
