#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MAX_N[] = {100 * 1000, 10, 3000, 3000, 100 * 1000, 100 * 1000};
const int MAX_COORD = 1000 * 1000 * 1000;
const int MAX_H[] = {MAX_COORD,  MAX_COORD, 1, MAX_COORD, 1, MAX_COORD}; 

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    assert(0 <= group && group <= 5);

    int n = inf.readInt(1, MAX_N[group], "N");
    inf.readSpace();
    int k = inf.readInt(1, MAX_COORD, "K");
    inf.readEoln();
    for (int i = 0; i < n; i++) {
        int left = inf.readInt(-MAX_COORD, MAX_COORD, "left");
        inf.readSpace();
        int right = inf.readInt(-MAX_COORD, MAX_COORD, "right");
        inf.readSpace();        
        int height = inf.readInt(1, MAX_H[group], "height");
        inf.readEoln();
        ensure(left <= right);    
        ensure(1 <= left);
        ensure(right <= k);
    }
    inf.readEof();
}
    
