#include <cstdio>
#include <algorithm>
using namespace std;

const int N = 3050;

int D[N];
int L[N], R[N], W[N];

const int inf = 1000 * 1000 * 1000 * 2 + 42;

int main() {
    int n, k;
    scanf("%d %d", &n, &k);
    vector<pair<int, int>> byR;
    for (int i = 0; i < n; i++) {
        scanf("%d %d %d", &L[i], &R[i], &W[i]);
        byR.emplace_back(R[i], i);
    }
    sort(byR.begin(), byR.end());
    int ans = inf;
    for (auto& pr : byR) {
        int i = pr.second;
        if (L[i] <= 1)
            D[i] = W[i];
        else
            D[i] = inf;
        for (auto& prv : byR) {
            int j = prv.second;
            if (j == i)
                break;
            if (R[j] >= L[i] - 1) {
                int here = W[i];
                if (R[j] >= L[i])
                    here = W[i] + W[j];
                D[i] = min(D[i], max(D[j], here));
            }
        }
        if (R[i] >= k)
            ans = min(ans, D[i]);
    }
    printf("%d\n", ans >= inf ? -1 : ans);
}
